#include<bits/stdc++.h>
using namespace std;
long long n,m,k;
long long dai[100005];
long long s[105],e[105];
bool check[10005];
bool visited[100005];
vector<long long> v[100005];
vector<long long>  bfs(long long start){
    for(long long i=0;i<n;i++){
        visited[i]=0;
    }
    vector<long long> ot;
    queue <long long> q;
    q.push(start);

    while(!q.empty()){
        long long h=q.front();

        for(long long i=0;i<v[h].size();i++){
            if(visited[v[h][i]]==0){
                q.push(v[h][i]);
            }
        }
        q.pop();
        visited[h]=true;
    }
    for(long long i=0;i<m;i++){
        if(visited[i]==true){
            ot.push_back(i);

        }
    }

    return ot;
}

int main(){
    long long a,b;
    cin>>n>>m>>k;
    for(long long i=0;i<m;i++){
        cin>>a>>b;
        v[a].push_back(b);

    }
  //  if(k==1){

   // }
   // else{
        for(long long i=0;i<k;i++){
            cin>>s[i]>>e[i];
        }
        vector <long long> h;
        for(long long i=0;i<k;i++){
                h.clear();
                h=bfs(s[i]);
                for(long long i2=0;i2<h.size();i2++){
                    dai[h[i2]]++;
                }

        }
        vector<long long> j;
        for(long long i=1;i<=n;i++){
            if(dai[i]==k){
               j.push_back(i);
            }
        }

        vector<long long> answer;
        vector<long long> z;
        for(long long i=0;i<j.size();i++){
            z.clear();
            for(long long i4=0;i4<=n;i4++){
                check[i4]=0;
            }
            long long l=0;

            z=bfs(j[i]);
            for(long long i2=0;i2<z.size();i2++){
                    check[z[i2]]++;
            }
            for(long long i3=0;i3<k;i3++){
                if(check[e[i3]]==1){
                    l++;
                }
            }
            if(l==k){
                answer.push_back(j[i]);
            }

        }
        cout<<answer.size()<<endl;
        for(long long i=0;i<answer.size();i++){
            cout<<answer[i]<<" ";
        }
   // }




    return 0;
}

